import 'package:walletpackage/walletpackage.dart';

void main() {
//  testChangePassword();
//  Wallet.createMnemonicAndAddress('123456');
  testImportMnemonicAndAddress();
//  testSignTransaction();
//  testCreateErc20Transaction();
}
void testCreateErc20Transaction() {
  String from = '0xE6279F32EBEAb34589F602Bb9b0224C70af9a9E4';
  String to = '0xa3b65Ba11F77F4B53A691fd722373D038418cDCE';
  int value = 16;
  int gasPrice = 10;
  int nonce = 1;
  String contract = '0xc9c4d9Ec2B44B241361707679D3Db0876aC10CA6';
  String hex = Wallet.createErc20Transaction('EUSDT', from, to, value, gasPrice, nonce);
  print(hex);
}
void testChangePassword() {
  String keystore =
      '{"crypto":{"cipher":"aes-128-ctr","cipherparams":{"iv":"6c02c795e7b3df21d7b88dee53a3e6bd"},"ciphertext":"658f02c82d551eae5bcec7beb7952d0ad8191f697c6b46e563179c2d8f4868304e08f60c0bd9c566c4aec35091fb4d4502c49f3f1d45d35279af68b84935f563","kdf":"scrypt","kdfparams":{"dklen":32,"n":8192,"r":8,"p":1,"salt":"9bd25b612f58d361b1f69728dc3ee5fe3f22775ddc6a29531111b0be74a6e9b1"},"mac":"c2182716ff042d48d587a727bc9ca338bb27e902ed121acf7b3a9446d9aae0b7"},"id":"0bb8fb48-a218-44b2-97b7-a9d263bb71de","version":3}';
  String passwd = '123456';
  String newPasswd = '456789';
  String newKeystore = Wallet.changePassword(keystore, passwd, newPasswd);
  print(newKeystore);
}

void testImportMnemonicAndAddress() {
  String mnemonic =
      'diagram frame frequent rain episode convince indoor thank retreat wheat vapor unusual';
  //String passwd = '123456';
  WalletData result = Wallet.importMnemonicAndAddress(mnemonic);
  print(result);
}

Future<void> testSignTransaction() async {
  String type = 'USDT';
  String keystore =
      '{"crypto":{"cipher":"aes-128-ctr","cipherparams":{"iv":"bee6e88f0532ee244c0f7df95b99971e"},"ciphertext":"25adea3182ad0c74e359c8459bad92b81aef746ceb1885eeb0529d2dd546a6bbb29f36265549df8695c0431e3ba5437943a558e474504533ce4a0d99dfa356a9","kdf":"scrypt","kdfparams":{"dklen":32,"n":8192,"r":8,"p":1,"salt":"558b27bb9e31499591d0140c60cb289387df8073149635af0992bde9729c36d9"},"mac":"059bc445295f9ba8a777e1be0f815d4ce97d82f18f27806a527cdc5eda1ab476"},"id":"d0dad9f0-fc42-4d0f-a89c-e7e41da75668","version":3}';
  String passwd = '456789';
  String txhex = '';
  String result = await Wallet.signTransaction(type, keystore, passwd, txhex);
  print(result);
}
